django/documents/urls.py
from django.urls import path

from . import views

app_name = 'documents'
urlpatterns = [
    path('', views.index, name="index"),
    path('category/<int:category_id>', views.check_category_permissions, name="check_category_permissions"),
    path('category/<int:category_id>/get_category_qr', views.get_category_qr, name="get_category_qr"),
    path('category/<int:document_id>/get_document_qr', views.get_document_qr, name="get_document_qr"),
]

django/ippo/urls.py
from django.conf.urls import url, include
from django.contrib import admin
from django.urls import path
from django.conf import settings
from django.conf.urls.static import static
from django.views.generic import RedirectView
from documents.views import protected_view
from ecm.views import protected_view as ecm_view
from django.views.static import serve

urlpatterns = [
                  url(r'^favicon\.ico$', RedirectView.as_view(url='/static/main/images/ippo.ico')),
                  path('admin/', admin.site.urls),
                  path('', include('main.urls')),
                  path('diplomas/', include('diplomas.urls')),
                  path('appointments/', include('appointment.urls')),
                  path('news/', include('news.urls')),
                  url(r'^ckeditor/', include('ckeditor_uploader.urls')),
                  path('subjects/', include('subjects.urls')),
                  path('documents/', include('documents.urls')),
                  path('schedule/', include('schedule.urls')),
                  path('people/', include('people.urls')),
                  path('library/', include('library.urls')),
                  url(r'^select2/', include('django_select2.urls')),
              ] + static(
    settings.STATIC_URL,
    document_root=settings.STATIC_ROOT
) + static(
    settings.MEDIA_URL,
    document_root=settings.MEDIA_ROOT
)
#
# if settings.DEBUG:
#     urlpatterns += [
#         url(
#             r"^{}/(?P<path>.*)$".format(settings.MEDIA_URL),
#             serve,
#             {"document_root": settings.MEDIA_ROOT, "show_indexes": True}
#         ),
#         url(
#             r"^{}/(?P<path>.*)$".format(settings.PROTECTED_MEDIA_URL),
#             serve,
#             {"document_root": settings.PROTECTED_MEDIA_ROOT, "show_indexes": True}
#         ),
#     ]
# else:
urlpatterns += [
    # url(
    #     r"^{}/(?P<path>.*)$".format(settings.PROTECTED_MEDIA_URL),
    #     protected_view
    # ),
    url(r'^protected/ecm/(?P<path>.*)$', ecm_view),
    url(r'^protected/(?P<path>.*)$', protected_view),
]

django/main/urls.py
from django.urls import path
from . import views

app_name = 'main'

urlpatterns = [
    path('', views.index, name="home"),
    path('about-<str:sub_cat>', views.about, name="about"),
    path('feedback', views.feedback, name="feedback"),
    path('teacher/<int:teacher_id>', views.about_teacher, name="teacher"),
    path('worker/<int:worker_id>', views.about_worker, name="worker"),
]

django/subjects/urls.py
from django.urls import path

from . import views

app_name = 'subjects'

urlpatterns = [
    path('', views.index, name="index"),
    path('speciality/<int:speciality_id>', views.speciality, name="speciality"),
    path('subject/<int:subject_id>', views.subject, name="subject"),
    path('search', views.search, name="search"),
]

django/ecm/models.py
from django.core.validators import FileExtensionValidator
from django.db import models
from django.utils.timezone import now

from main import storage
from people.models import Worker


class Category(models.Model):
    name = models.CharField(max_length=128, unique=True, verbose_name='Название')

    class Meta:
        verbose_name = "Тип"
        verbose_name_plural = "Типы"
        ordering = ['name']

    def __str__(self):
        return self.name


class Document(models.Model):
    DIRECTION_CHOICES = [('вхд', 'Входящий'), ('исх', 'Исходящий'), ('внт', 'Внутренний')]
    direction = models.CharField(choices=DIRECTION_CHOICES, max_length=3, verbose_name='Вид')
    category = models.ForeignKey(Category, models.CASCADE, verbose_name='Тип')
    creation_date = models.DateField(default=now, verbose_name='Дата создания')
    register_date = models.DateField(null=True, blank=True, verbose_name='Дата регистрации')
    to_whom = models.ManyToManyField(Worker, related_name='recipient', verbose_name='Кому')
    from_whom = models.ForeignKey(Worker, on_delete=models.SET_NULL, null=True, related_name='initiator',
                                  verbose_name='От кого')
    executor = models.ForeignKey(Worker, on_delete=models.SET_NULL, null=True, blank=True, related_name='executor',
                                 verbose_name='Исполнитель')
    pdf_file = models.FileField(upload_to=storage.upload_ecm_document, storage=storage.ProtectedFileSystemStorage(),
                                validators=[FileExtensionValidator(allowed_extensions=['pdf'])], null=True, blank=True,
                                verbose_name='PDF')
    docx_file = models.FileField(upload_to=storage.upload_ecm_document, storage=storage.ProtectedFileSystemStorage(),
                                 validators=[FileExtensionValidator(allowed_extensions=['docx'])], null=True,
                                 blank=True, verbose_name='DOCX')
    code = models.CharField(max_length=32, unique_for_month=True, verbose_name='Код', blank=True)

    class Meta:
        verbose_name = "Документ"
        verbose_name_plural = "Документы"
        ordering = ['-creation_date']

    def __str__(self):
        return f'{self.get_direction_display()} {self.category} {self.creation_date}'

    def save(self, *args, **kwargs):
        temp_pdf_file = self.pdf_file
        temp_docx_file = self.docx_file
        if not self.id:
            self.pdf_file = None
            self.docx_file = None
            super(Document, self).save(*args, **kwargs)
            code = self.direction + str(self.creation_date.strftime("%y%m"))

            # map_dir = enumerate(self.DIRECTION_CHOICES, 1)
            # for m in map_dir:
            #     if self.direction in m[1][0]:
            #         code += str(m[0])

            suffix = 0
            while Document.objects.filter(code=code + str(suffix).zfill(2)):
                suffix += 1

            self.code = code + str(suffix).zfill(2)
            super(Document, self).save(*args, **kwargs)
            self.pdf_file = temp_pdf_file
            self.docx_file = temp_docx_file
            super(Document, self).save(*args, **kwargs)
        else:
            super(Document, self).save(*args, **kwargs)

django/subjects/models.py
from django.db import models
from ckeditor_uploader.fields import RichTextUploadingField
from news.models import my_slugify


class Speciality(models.Model):
    GRADE_CHOICES = [('b', 'Бакалавриат'), ('m', 'Магистратура')]
    grade = models.CharField('Степень', choices=GRADE_CHOICES, default='b', max_length=1)
    cipher = models.CharField(max_length=16, unique=True, verbose_name='Шифр')
    name = models.CharField(max_length=128, verbose_name='Название')
    description = RichTextUploadingField(null=True, blank=True, default='', verbose_name='Описание')

    class Meta:
        verbose_name = "Направление"
        verbose_name_plural = "Направления"
        ordering = ['cipher', 'name']

    def __str__(self):
        return f'{self.get_grade_display()} {self.cipher} {self.name}'


class Category(models.Model):
    name = models.CharField(max_length=128, verbose_name='Название')

    def __str__(self):
        return self.name

    class Meta:
        verbose_name = "Категория"
        verbose_name_plural = "Категории"
        ordering = ['name']


class Material(models.Model):
    category = models.ForeignKey(Category, on_delete=models.CASCADE, verbose_name='Категория')
    part = models.PositiveSmallIntegerField(blank=True, null=True, default=None, verbose_name='Семестр')
    name = models.CharField(max_length=256, verbose_name='Имя')
    file = models.FileField(upload_to='materials/', max_length=512, verbose_name='Файл')

    class Meta:
        verbose_name = "Материал"
        verbose_name_plural = "Материалы"
        ordering = ['part', 'category', 'name']

    def __str__(self):
        return self.name


class Subject(models.Model):
    speciality = models.ForeignKey(Speciality, related_name="subjects", on_delete=models.CASCADE,
                                   verbose_name='Направление')
    name = models.CharField(max_length=256, verbose_name='Название')
    content = RichTextUploadingField(verbose_name='Описание', blank=True)
    materials = models.ManyToManyField(Material, verbose_name='Материалы', blank=True)
    slug = models.CharField(max_length=256, verbose_name='Ссылка', blank=True,
                            help_text='Сгенерируется после первого сохранения. Потом можно менять вручную')

    class Meta:
        verbose_name = "Дисциплина"
        verbose_name_plural = "Дисциплины"
        ordering = ['name']

    def __str__(self):
        return self.name

    def save(self, *args, **kwargs):
        if not self.id:
            self.slug = my_slugify(self.name)
        super(Subject, self).save(*args, **kwargs)

django/subjects/views.py
from django.shortcuts import render, get_object_or_404

from .models import Subject, Speciality


def index(request):
    specialities = Speciality.objects.all()

    context = {
        'specialities': specialities,
    }
    return render(request, 'subjects/index.html', context)


def speciality(request, speciality_id):
    specialities = Speciality.objects.all()
    current_speciality = get_object_or_404(Speciality, pk=speciality_id)
    subjects = Subject.objects.filter(speciality=current_speciality).exclude(name='[ДРУГОЕ]')
    context = {
        'specialities': specialities,
        'subjects': subjects,
        'current_speciality': current_speciality,
    }
    return render(request, 'subjects/list.html', context)


def subject(request, subject_id):
    subject = get_object_or_404(Subject, pk=subject_id)
    context = {
        'subject': subject,
    }
    return render(request, 'subjects/subject.html', context)


def search(request):
    query = request.GET.get('q')
    subjects = Subject.objects.filter(name__icontains=query) | Subject.objects.filter(content__icontains=query)
    context = {
        'subjects': subjects,
        'query': query,
    }

    return render(request, 'subjects/results.html', context)

django/subjects/templates/subjects/index.html
{% extends 'main/base.html' %}
{% load static %}
{% block title %}Дисциплины{% endblock %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb 'Дисциплины' 'subjects:index' %}
{% endblock %}
{% block content %}
  {% render_breadcrumbs %}
  <section class="container-fluid flex-grow">
    <div class="container">
      <div class="row">
        <div class="col-sm-6">
          <form class="form-inline" action="{% url "subjects:search" %}" method="get">
            <div class="input-group flex-nowrap col" id="my-search">
              <input class="form-control col" type="search" placeholder="поиск" aria-label="Search" name="q"
                     aria-describedby="addon-wrapping" {% if search %} value={{ search }} {% endif %}>
              <div class="input-group-append">
                <button class="btn btn-primary" type="submit"><i class="fa fa-search"></i></button>
              </div>
            </div>
          </form>
        </div>
      </div>
    </div>

    {% block list %}
      <div class="container">
        <div class="row">
          <div class="col">
            <div class="accordion" id="accordionExample">
              <div class="card">
                <div class="card-header" id="headingOne">
                  <h2 class="mb-0">
                    <button class="btn btn-link" type="button" data-toggle="collapse" data-target="#collapseOne"
                            aria-expanded="true" aria-controls="collapseOne">
                      Бакалавриат
                    </button>
                  </h2>
                </div>
                <div id="collapseOne" class="collapse show" aria-labelledby="headingOne"
                     data-parent="#accordionExample">
                  <div class="card-body">
                    <div class="list-group list-group-flush">
                      {% for speciality in specialities %}
                        {% if speciality.grade == 'b' %}
                          <a href="{% url 'subjects:speciality' speciality.id %}"
                             class="list-group-item list-group-item-action">
                            {{ speciality.cipher }} {{ speciality.name }}
                          </a>
                        {% endif %}
                      {% endfor %}
                    </div>
                  </div>
                </div>
              </div>
              <div class="card">
                <div class="card-header" id="headingTwo">
                  <h2 class="mb-0">
                    <button class="btn btn-link collapsed" type="button" data-toggle="collapse"
                            data-target="#collapseTwo"
                            aria-expanded="false" aria-controls="collapseTwo">
                      Магистратура
                    </button>
                  </h2>
                </div>
                <div id="collapseTwo" class="collapse" aria-labelledby="headingTwo" data-parent="#accordionExample">
                  <div class="card-body">
                    <div class="list-group list-group-flush">
                      {% for speciality in specialities %}
                        {% if speciality.grade == 'm' %}
                          <a href="{% url 'subjects:speciality' speciality.id %}"
                             class="list-group-item list-group-item-action">
                            {{ speciality.cipher }} {{ speciality.name }}
                          </a>
                        {% endif %}
                      {% endfor %}
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    {% endblock %}
  </section>
{% endblock %}

django/subjects/templates/subjects/list.html
{% extends 'subjects/index.html' %}
{% load static %}

{% block title %}{{ current_speciality.cipher }}{% endblock %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {{ block.super }}
  {% if query %}
  {% else %}
    {% breadcrumb current_speciality.cipher 'subjects:index' current_speciality.id %}
  {% endif %}
{% endblock %}
{% block list %}
  <div class="container" align="justify">
    {{ current_speciality.description|safe }}
  </div>
  <ul style="list-style: none">
    {% for subject in subjects %}
      <li style="list-style: none"><a href="{% url 'subjects:subject' subject.id %}">{{ subject }}</a></li>
    {% endfor %}
  </ul>
  </div>
{% endblock %}

django/subjects/templates/subjects/results.html
{% extends 'subjects/list.html' %}
{% load static %}
{% block title %}Результаты поиска по запросу "{{ query }}" - Дисциплины{% endblock %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb query "subjects:index" %}
{% endblock %}

django/subjects/templates/subjects/subject.html
{% extends 'subjects/index.html' %}
{% load static %}

{% block title %}{{ subject }}{% endblock %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb subject 'subjects:subject' subject.id %}
{% endblock %}
{% block content %}
  {% render_breadcrumbs %}
  <section class="container-fluid flex-grow">
    <div class="container">
      {% if perms.subjects.change_subject %}
        <a href="/admin/subjects/subject/{{ subject.id }}/change/"><i class="far fa-edit"></i></a>
      {% endif %}
      <div class="tab-content" id="v-pills-tabContent">
        <div class="tab-pane fade show active" id="v-pills-{{ subject.id }}" role="tabpanel"
             aria-labelledby="v-pills-{{ subject.id }}-tab">
          <nav>
            <div class="nav nav-tabs" id="nav-tab-{{ subject.id }}" role="tablist">
              <a class="nav-item nav-link active" id="nav-about-tab-{{ subject.id }}"
                 data-toggle="tab"
                 href="#nav-about-{{ subject.id }}"
                 role="tab" aria-controls="nav-about-{{ subject.id }}" aria-selected="true">О
                дисциплине</a>
              <a class="nav-item nav-link" id="nav-materials-tab-{{ subject.id }}" data-toggle="tab"
                 href="#nav-materials-{{ subject.id }}"
                 role="tab" aria-controls="nav-materials-{{ subject.id }}" aria-selected="false">Материалы
                дисциплины</a>
            </div>
          </nav>
          <div class="tab-content" id="nav-tabContent-{{ subject.id }}">
            <div class="tab-pane fade show active" id="nav-about-{{ subject.id }}" role="tabpanel"
                 aria-labelledby="nav-about-tab-{{ subject.id }}">
              <p>{{ subject.speciality }}</p>
              {{ subject.content|safe }}
              {% for teacher in subject.teachers.all %}
                <a href="{% url 'main:teacher' teacher.id %}"><h6
                    class="card-title">{{ teacher.last_name }} {{ teacher.first_name }} {{ teacher.middle_name }}</h6>
                </a>
              {% endfor %}
            </div>
            <div class="tab-pane fade" id="nav-materials-{{ subject.id }}" role="tabpanel"
                 aria-labelledby="nav-materials-tab-{{ subject.id }}">
              <table id="documents-table" class="table table-bordered">
                <thead>
                <tr>
                  <th>Семестр</th>
                  <th>Название</th>
                  <th>Ссылка</th>
                </tr>
                </thead>
                <tbody>
                {% for m in subject.materials.all %}
                  <tr>
                    <td>{% if m.part %}{{ m.part }}{% endif %}</td>
                    <td><h6>{{ m.name }}</h6>
                      {{ m.category }}
                    </td>
                    <td>
                      <p><a href="{{ m.file.url }}"><i class="far fa-file"></i></a></p>
                      {#                    <a href="{% url 'documents:get_document_qr' document.id %}"> <i class="fas fa-qrcode"></i></a>#}
                      {% if perms.documents.change_document %}
                        <a href="/admin/subjects/material/{{ m.id }}/change/"><i class="far fa-edit"></i></a>
                      {% endif %}
                    </td>
                  </tr>
                {% endfor %}
                </tbody>
              </table>
            </div>
          </div>
        </div>
      </div>
    </div>
  </section>
{% endblock %}